/* :mode=JP-SQL:folding=explicit:collapseFolds=1:indentSize=3: */

* current_version _
SELECT DB_VERSION FROM GPD_DBINFO;

\p Current GPD DB Version: *{current_version}

* upgraded = false

* if (*current_version < 3)
   \p Upgrading from v*{current_version} to v3...
   
   CREATE CACHED TABLE IF NOT EXISTS PATIENT_FILES_CONTENTS
      (
      patient_id INTEGER NOT NULL,
      filename VARCHAR(256),
      contents BLOB,
      checksum INTEGER,
      CONSTRAINT patient_files_contents_ref FOREIGN KEY (patient_id) REFERENCES PATIENT (patient_id)
      );
   
   CREATE CACHED TABLE IF NOT EXISTS TREATMENT_DATA_CONTENTS
      (
      treatment_id INTEGER NOT NULL,
      datastring VARCHAR(256),
      contents BLOB,
      checksum INTEGER,
      CONSTRAINT treatment_data_contents_ref FOREIGN KEY (treatment_id) REFERENCES TREATMENT (treatment_id)
      );
   
   CREATE CACHED TABLE IF NOT EXISTS TREATMENT_FILES_CONTENTS
      (
      treatment_id INTEGER NOT NULL,
      filename VARCHAR(256),
      contents BLOB,
      checksum INTEGER,
      CONSTRAINT treatment_files_contents_ref FOREIGN KEY (treatment_id) REFERENCES TREATMENT (treatment_id)
      );

   * current_version = 3
   * upgraded = true
* end if

* if (*current_version < 4)
   \p Upgrading from v*{current_version} to v4...
   ALTER TABLE TREATMENT ADD COLUMN IF NOT EXISTS finalized BOOLEAN DEFAULT FALSE;
   ALTER TABLE PATIENT ADD COLUMN IF NOT EXISTS finalized BOOLEAN DEFAULT FALSE;
   * current_version = 4
   * upgraded = true
* end if


* if (*upgraded == true)
   \p DB_VERSION upgraded to v*{current_version}
   \i @/define-routines.sql   -- procedures may have changed; redefine
   UPDATE GPD_DBINFO SET DB_VERSION = *{current_version};
   COMMIT;
* end if

* - current_version
* - upgraded
